#!/usr/local/bin/perl

# Greg Stitt
# This script will fo the following
# 1) create rom files for each instruction and write them to avgpwrroms
# 2) for each rom file, it will synthesize, power analysis, and output results
#    to a file in the ins_pwr_hrchy directory
# 3) output overall power per instruction to inspower.txt and will categorize
#    the data in inspower.xdu

$num_args = scalar @ARGV;

if ($num_args > 1 || ($num_args == 1 && $ARGV[0] ne "-ALL")) {
    print "usage: $0 [-ALL]\n";
    exit;
}

system("rm -rf work");
system("mkdir work");

# synthesizes all2 if ALL is a parameter
if ($num_args == 1) {
    system("dc_shell -f syn_all2.inc > all2.out");
}

system("mkinsroms.pl");

system("rm -rf ins_pwr_hrchy");
system("mkdir ins_pwr_hrchy");

system("make clean -C pwr_hrchy > makeclean.out 2>> makeclean2.out");
system("make -C pwr_hrchy > make.out 2>> make2.out");

system("rm -f totalpow.txt");

system("cp -f run_scripts/insrun.scr run.scr");

opendir ROMDIR, "avgpwrroms" or die "Can't open avgpwrroms directory";
@allfiles = readdir ROMDIR;
closedir ROMDIR;

foreach $file (@allfiles) {
   
    if ($file !~ /^\./) {
	system("cp -f \"avgpwrroms/$file\" i8051_rom.vhd\n");

	# synthesizes the current rom and writes result of power analysis to
	# netpower.out
	system("synrompow.scr");
	
	open INFILE, "netpower.out" or die "Can't open netpower.out\n";
	open POWERFILE, ">>totalpow.txt" or die "Can't open totalpow.txt\n";

	# gets line with power and writes it to totalpow.txt
	while (<INFILE>) {
            if (/Total \(\d* nets\)/) {
		@power_args = split;
		@new_file = split (/[ \t.]/, $file, 2);

                print POWERFILE "$new_file[0]\t$power_args[3]\n";
                break;
            }
        }

	close POWERFILE;
	close INFILE;
	
	# get filename, write power heirarchy to file.xdu
	@file_name = split /[ \t.]/, $file, 2;
	system("pwr_hrchy/pwr_hrchy netpower.out > \"ins_pwr_hrchy/$file_name[0].xdu\"");
#	system("cp -f netpower.out \"inspow/$file.out\"");
    }
}

system("outputinspow.pl");










