--
-- Copyright (c) 1999 Tony Givargis.  Permission to copy is granted
-- provided that this header remains intact.  This software is provided
-- with no warranties.
--
-- Version : 2.4
--

-------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_ARITH.all;
--use WORK.I8051_LIB.all;

-------------------------------------------------------------------------------

entity I8051_ALL is
    port(rst    : in  STD_LOGIC;
         clk    : in  STD_LOGIC;
         p0_in  : in  UNSIGNED (7 downto 0);
         p0_out : out UNSIGNED (7 downto 0);
         p1_in  : in  UNSIGNED (7 downto 0);
         p1_out : out UNSIGNED (7 downto 0);
         p2_in  : in  UNSIGNED (7 downto 0);
         p2_out : out UNSIGNED (7 downto 0);
         p3_in  : in  UNSIGNED (7 downto 0);
         p3_out : out UNSIGNED (7 downto 0));
end I8051_ALL;

-------------------------------------------------------------------------------

architecture STR of I8051_ALL is

    component I8051_ROM
        port(rst      : in  STD_LOGIC;
             clk      : in  STD_LOGIC;
             addr     : in  UNSIGNED (11 downto 0);
             data     : out UNSIGNED (7 downto 0);
             rd       : in  STD_LOGIC);
    end component;

    component I8051_ALL2
     port(rst    : in  STD_LOGIC;
         clk    : in  STD_LOGIC;        
         p0_in  : in  UNSIGNED (7 downto 0);
         p0_out : out UNSIGNED (7 downto 0);
         p1_in  : in  UNSIGNED (7 downto 0);
         p1_out : out UNSIGNED (7 downto 0);
         p2_in  : in  UNSIGNED (7 downto 0);
         p2_out : out UNSIGNED (7 downto 0);
         p3_in  : in  UNSIGNED (7 downto 0);
         p3_out : out UNSIGNED (7 downto 0);

         -- used to remove ROM for total design
         
         rom_addr   : out  UNSIGNED (11 downto 0);
         rom_data   : in UNSIGNED (7 downto 0);
         rom_rd     : out  STD_LOGIC);
    end component;
       
    signal rom_addr         : UNSIGNED (11 downto 0);
    signal rom_data         : UNSIGNED (7 downto 0);
    signal rom_rd           : STD_LOGIC;

begin
    
    U_ROM : I8051_ROM port map(rst,
                               clk,
                               rom_addr,
                               rom_data,
                               rom_rd);


    U_ALL2 : I8051_ALL2 port map(rst, clk, p0_in, p0_out, p1_in, p1_out,
                                p2_in, p2_out, p3_in, p3_out, rom_addr,
                                rom_data, rom_rd);
    
end STR;

-------------------------------------------------------------------------------

-- end of file --

