
library IEEE,LSI_10K;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use LSI_10K.COMPONENTS.all;

package CONV_PACK_I8051_ROM is

-- define attributes
attribute ENUM_ENCODING : STRING;

-- define any necessary types
--type UNSIGNED is array (INTEGER range <>) of std_logic;

end CONV_PACK_I8051_ROM;

library IEEE,LSI_10K;

use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use LSI_10K.COMPONENTS.all;

use work.CONV_PACK_I8051_ROM.all;

entity I8051_ROM is

   port( rst, clk : in std_logic;  addr : in UNSIGNED (11 downto 0);  data : 
         out UNSIGNED (7 downto 0);  rd : in std_logic);

end I8051_ROM;

architecture SYN of I8051_ROM is

   component NR2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component EN
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component AN2
      port( A, B : in std_logic;  Z : out std_logic);
   end component;
   
   component FD1P
      port( D, CP : in std_logic;  Q, QN : out std_logic);
   end component;
   
   signal member76_5_port, member76_7_port, member76_6_port, n183, n184, n196, 
      n197, n198, n199, n200, n201, n202, n203 : std_logic;

begin
   
   n183 <= '0';
   U34 : NR2 port map( A => addr(2), B => addr(1), Z => member76_7_port);
   U35 : EN port map( A => addr(1), B => addr(0), Z => n184);
   U36 : AN2 port map( A => addr(0), B => member76_7_port, Z => member76_6_port
                           );
   U37 : NR2 port map( A => n184, B => addr(2), Z => member76_5_port);
   data_reg_7_label : FD1P port map( D => member76_7_port, CP => clk, Q => 
                           data(7), QN => n196);
   data_reg_6_label : FD1P port map( D => member76_6_port, CP => clk, Q => 
                           data(6), QN => n197);
   data_reg_5_label : FD1P port map( D => member76_5_port, CP => clk, Q => 
                           data(5), QN => n198);
   data_reg_4_label : FD1P port map( D => member76_6_port, CP => clk, Q => 
                           data(4), QN => n199);
   data_reg_3_label : FD1P port map( D => member76_6_port, CP => clk, Q => 
                           data(3), QN => n200);
   data_reg_2_label : FD1P port map( D => member76_6_port, CP => clk, Q => 
                           data(2), QN => n201);
   data_reg_1_label : FD1P port map( D => member76_5_port, CP => clk, Q => 
                           data(1), QN => n202);
   data_reg_0_label : FD1P port map( D => n183, CP => clk, Q => data(0), QN => 
                           n203);

end SYN;
