//-----------------------------------------------------------------------------

// Roman Lysecky, Tony Givargis, and Greg Stitt
// Copyright 1999, All Rights Reserved.

//-----------------------------------------------------------------------------

#ifndef _8051_CONST_
#define _8051_CONST_
//-----------------------------------------------------------------------------

static const unsigned int RomSize = 65536;
static const unsigned int RamSize = 384;
static const unsigned int NumIns = 111;

//-----------------------------------------------------------------------------

#define MAX_FILE_NAME 255

//-----------------------------------------------------------------------------

enum Opcode {
    ACALL, ADD1,  ADD2,  ADD3,  ADD4,  ADDC1, ADDC2, ADDC3, ADDC4,
    AJMP,  ANL1,  ANL2,  ANL3,  ANL4,  ANL5,  ANL6,  ANL7,  ANL8, 
    CJNE1, CJNE2, CJNE3, CJNE4, CLR1,  CLR2,  CLR3,  CPL1,  CPL2,  
    CPL3,  DA,    DEC1,  DEC2,  DEC3,  DEC4,  DIV,   DJNZ1, DJNZ2, 
    INC1,  INC2,  INC3,  INC4,  INC5,  JB,    JBC,   JC,    JMP,   
    JNB,   JNC,   JNZ,   JZ,    LCALL, LJMP,  MOV1,  MOV2,  MOV3,  
    MOV4,  MOV5,  MOV6,  MOV7,  MOV8,  MOV9,  MOV10, MOV11, MOV12, 
    MOV13, MOV14, MOV15, MOV16, MOV17, MOV18, MOVC1, MOVC2, MOVX1, 
    MOVX2, MOVX3, MOVX4, MUL,   NOP,   ORL1,  ORL2,  ORL3,  ORL4,  
    ORL5,  ORL6,  ORL7,  ORL8,  POP,   PUSH,  RET,   RETI,  RL,    
    RLC,   RR,    RRC,   SETB1, SETB2, SJMP,  SUBB1, SUBB2, SUBB3, 
    SUBB4, SWAP,  XCH1,  XCH2,  XCH3,  XCHD,  XRL1,  XRL2,  XRL3,  
    XRL4,  XRL5,  XRL6
};

//----------------------------------------------------------------------------

static const char* InsNameTbl[] = {
    { "ACALL" },
    { "ADD_1" },
    { "ADD_2" },
    { "ADD_3" },
    { "ADD_4" },
    { "ADDC_1" },
    { "ADDC_2" },
    { "ADDC_3" },
    { "ADDC_4" },
    { "AJMP" },
    { "ANL_1" },
    { "ANL_2" },
    { "ANL_3" },
    { "ANL_4" },
    { "ANL_5" },
    { "ANL_6" },
    { "ANL_7" },
    { "ANL_8" },
    { "CJNE_1" },
    { "CJNE_2" },
    { "CJNE_3" },
    { "CJNE_4" },
    { "CLR_1" },
    { "CLR_2" },
    { "CLR_3" },
    { "CPL_1" },
    { "CPL_2" },
    { "CPL_3" },
    { "DA" },
    { "DEC_1" },
    { "DEC_2" },
    { "DEC_3" },
    { "DEC_4" },
    { "DIV" },
    { "DJNZ_1" },
    { "DJNZ_2" },
    { "INC_1" },
    { "INC_2" },
    { "INC_3" },
    { "INC_4" },
    { "INC_5" },
    { "JB" },
    { "JBC" },
    { "JC" },
    { "JMP" },
    { "JNB" },
    { "JNC" },
    { "JNZ" },
    { "JZ" },
    { "LCALL" },
    { "LJMP" },
    { "MOV_1" },
    { "MOV_2" },
    { "MOV_3" },
    { "MOV_4" },
    { "MOV_5" },
    { "MOV_6" },
    { "MOV_7" },
    { "MOV_8" },
    { "MOV_9" },
    { "MOV_10" },
    { "MOV_11" },
    { "MOV_12" },
    { "MOV_13" },
    { "MOV_14" },
    { "MOV_15" },
    { "MOV_16" },
    { "MOV_17" },
    { "MOV_18" },
    { "MOVC_1" },
    { "MOVC_2" },
    { "MOVX_1" },
    { "MOVX_2" },
    { "MOVX_3" },
    { "MOVX_4" },
    { "MUL" },
    { "NOP" },
    { "ORL_1" },
    { "ORL_2" },
    { "ORL_3" },
    { "ORL_4" },
    { "ORL_5" },
    { "ORL_6" },
    { "ORL_7" },
    { "ORL_8" },
    { "POP" },
    { "PUSH" },
    { "RET" },
    { "RETI" },
    { "RL" },
    { "RLC" },
    { "RR" },
    { "RRC" },
    { "SETB_1" },
    { "SETB_2" },
    { "SJMP" },
    { "SUBB_1" },
    { "SUBB_2" },
    { "SUBB_3" },
    { "SUBB_4" },
    { "SWAP" },
    { "XCH_1" },
    { "XCH_2" },
    { "XCH_3" },
    { "XCHD" },
    { "XRL_1" },
    { "XRL_2" },
    { "XRL_3" },
    { "XRL_4" },
    { "XRL_5" },
    { "XRL_6" }
};

#endif
