//-------------------------------------------------------------------------

// Greg Stitt

//-------------------------------------------------------------------------
// This file handles the tracing of instruction power and frequencies
//-------------------------------------------------------------------------

#ifndef _PMEMPWR_
#define _PMEMPWR_

#include <algorithm>
#include "i8051_const.h"

#define MAX_INS_NAME 20

//-----------------------------------------------------------------------

struct PwrStats {
  Opcode ins;
  unsigned long freq;
  double pwr;
  double freq_pwr;
};

//----------------------------------------------------------------------

struct InsCountStats {
  Opcode ins;
  unsigned long freq;

  bool operator<(const InsCountStats &a) const {
    return a.freq < freq;
  }
};

class PmemPwr {
private:
  PwrStats ROM[RomSize];
  double InsPwr[NumIns];  // stores power of each instruction
  InsCountStats InsFreq[NumIns];

public:
  PmemPwr();
  ~PmemPwr();
  
  bool UpdateAddr(unsigned short PC, Opcode ins);
  bool PrintPower(char* output="pmempwr.out");
  bool PrintFreq(char* output="insfreq.out");
  bool GetPower(char *input="inspower.txt");
};


#endif







