#!/usr/local/bin/perl

# Greg Stitt
# This file will correct the results by removing the SJMP back the
# beginning from the power. 

#constant amount of time for sjmp instruction
$INS_EXEC_TIME = 850;
$NANO = 1000000000;

#fill table with extra bytes required for each instruction
$ins_table{"ACALL"} = 1;
$ins_table{"ADD_1"} = 0;
$ins_table{"ADD_2"} = 1;
$ins_table{"ADD_3"} = 0;
$ins_table{"ADD_4"} = 1;
$ins_table{"ADDC_1"} = 0;
$ins_table{"ADDC_2"} = 1;
$ins_table{"ADDC_3"} = 0;
$ins_table{"ADDC_4"} = 1;
$ins_table{"AJMP"} = 1;
$ins_table{"ANL_1"} = 0;
$ins_table{"ANL_2"} = 1;
$ins_table{"ANL_3"} = 0;
$ins_table{"ANL_4"} = 1;
$ins_table{"ANL_5"} = 1;
$ins_table{"ANL_6"} = 2;
$ins_table{"ANL_7"} = 1;
$ins_table{"ANL_8"} = 1;
$ins_table{"CJNE_1"} = 2;
$ins_table{"CJNE_2"} = 2;
$ins_table{"CJNE_3"} = 2;
$ins_table{"CJNE_4"} = 2;
$ins_table{"CLR_1"} = 0;
$ins_table{"CLR_2"} = 0;
$ins_table{"CLR_3"} = 1;
$ins_table{"CPL_1"} = 0;
$ins_table{"CPL_2"} = 0;
$ins_table{"CPL_3"} = 1;
$ins_table{"DA"} = 0;
$ins_table{"DEC_1"} = 0;
$ins_table{"DEC_2"} = 0;
$ins_table{"DEC_3"} = 1;
$ins_table{"DEC_4"} = 0;
$ins_table{"DIV"} = 0;
$ins_table{"DJNZ_1"} = 1;
$ins_table{"DJNZ_2"} = 2;
$ins_table{"INC_1"} = 0;
$ins_table{"INC_2"} = 0;
$ins_table{"INC_3"} = 1;
$ins_table{"INC_4"} = 0;
$ins_table{"INC_5"} = 0;
$ins_table{"JB"} = 2;
$ins_table{"JBC"} = 2;
$ins_table{"JC"} = 1;
$ins_table{"JMP"} = 0;
$ins_table{"JNB"} = 2;
$ins_table{"JNC"} = 1;
$ins_table{"JNZ"} = 1;
$ins_table{"JZ"} = 1;
$ins_table{"LCALL"} = 2;
$ins_table{"LJMP"} = 2;
$ins_table{"MOV_1"} = 0;
$ins_table{"MOV_2"} = 1;
$ins_table{"MOV_3"} = 0;
$ins_table{"MOV_4"} = 1;
$ins_table{"MOV_5"} = 0;
$ins_table{"MOV_6"} = 1;
$ins_table{"MOV_7"} = 1;
$ins_table{"MOV_8"} = 1;
$ins_table{"MOV_9"} = 1;
$ins_table{"MOV_10"} = 2;
$ins_table{"MOV_11"} = 1;
$ins_table{"MOV_12"} = 2;
$ins_table{"MOV_13"} = 0;
$ins_table{"MOV_14"} = 1;
$ins_table{"MOV_15"} = 1;
$ins_table{"MOV_16"} = 1;
$ins_table{"MOV_17"} = 1;
$ins_table{"MOV_18"} = 2;
$ins_table{"MOVC_1"} = 0;
$ins_table{"MOVC_2"} = 0;
$ins_table{"MOVX_1"} = 0;
$ins_table{"MOVX_2"} = 0;
$ins_table{"MOVX_3"} = 0;
$ins_table{"MOVX_4"} = 0;
$ins_table{"MUL"} = 0;
$ins_table{"NOP"} = 0;
$ins_table{"ORL_1"} = 0;
$ins_table{"ORL_2"} = 1;
$ins_table{"ORL_3"} = 0;
$ins_table{"ORL_4"} = 1;
$ins_table{"ORL_5"} = 1;
$ins_table{"ORL_6"} = 2;
$ins_table{"ORL_7"} = 1;
$ins_table{"ORL_8"} = 1;
$ins_table{"POP"} = 1;
$ins_table{"PUSH"} = 1;
$ins_table{"RET"} = 0;
$ins_table{"RETI"} = 0;
$ins_table{"RL"} = 0;
$ins_table{"RLC"} = 0;
$ins_table{"RR"} = 0;
$ins_table{"RRC"} = 0;
$ins_table{"SETB_1"} = 0;
$ins_table{"SETB_2"} = 1;
$ins_table{"SJMP"} = 1;
$ins_table{"SUBB_1"} = 0;
$ins_table{"SUBB_2"} = 1;
$ins_table{"SUBB_3"} = 0;
$ins_table{"SUBB_4"} = 1;
$ins_table{"SWAP"} = 0;
$ins_table{"XCH_1"} = 0;
$ins_table{"XCH_2"} = 1;
$ins_table{"XCH_3"} = 0;
$ins_table{"XCHD"} = 0;
$ins_table{"XRL_1"} = 0;
$ins_table{"XRL_2"} = 1;
$ins_table{"XRL_3"} = 0;
$ins_table{"XRL_4"} = 1;
$ins_table{"XRL_5"} = 1;
$ins_table{"XRL_6"} = 2;

# get the simulation time
open RUNFILE, "run.scr" or die "Can't open run.scr\n";
while (<RUNFILE>) {
    if (/^run/) {
	($run, $time) = split;
    }
}  

# get the number of sjmps that occur in each simulation
system("simbyte.scr > simbyte.out");
system("cp -f trace.out trace1.out");
open TRACE, "trace1.out";
$count0 = 0;
while (<TRACE>) {
    if(/SJMP/) {
	$count0 ++;
    }
}
close TRACE;

system("sim2byte.scr >> simbyte.out");
system("cp -f trace.out trace2.out");
open TRACE, "trace2.out";
$count1 = 0;
while (<TRACE>) {
    if(/SJMP/) {
	$count1 ++;
    }
}
close TRACE;

system("sim3byte.scr >> simbyte.out");
system("cp -f trace.out trace3.out");
open TRACE, "trace3.out";
$count2 = 0;
while (<TRACE>) {
    if(/SJMP/) {
	$count2 ++;
    }
}
close TRACE;

#print "$count0, $count1, $count2\n";

# fill total_power table
open INFILE, "totalpow.txt" or die "Can't open totalpow.txt\n";
while (<INFILE>) {
    
    @power_args = split;
    $total_power{$power_args[0]} = $power_args[1];
}
close INFILE;

$energy_per_sjmp = $total_power{'SJMP'} * ($INS_EXEC_TIME / $NANO);

# remove SJMP from power and insert into ins_power table
foreach $ins (keys %total_power) {
    	
    if ($ins_table{$ins} == 0) {
	$sjmp_count = $count0;
    }
    elsif ($ins_table{$ins} == 1) {
	$sjmp_count = $count1;
    }
    elsif ($ins_table{$ins} == 2) {
	$sjmp_count = $count2;
    }
    
    # get energy and actual time
    $total_en = $total_power{$ins} * ($time / $NANO);
    $sjmp_en = $energy_per_sjmp * $sjmp_count;
    $new_time = ($time - $sjmp_count * $INS_EXEC_TIME) / $NANO;
 
    # get actual power for current instruction
    $ins_power{$ins} = 	($total_en - $sjmp_en) / $new_time;
}

$ins_power{'SJMP'} = $total_power{'SJMP'};

open OUTFILE, ">inspower.txt" or die "Can't open output file\n";
foreach $ins (sort keys %ins_power) {
    print OUTFILE "$ins\t$ins_power{$ins}\n";
}
close OUTFILE;

system("formatinspwr.pl inspower.txt inspower.xdu");






