#!/usr/local/bin/perl

# This script runs all of the hex files in the test directory and 
# generates an architectural power heirarchy file that is placed in the 
# ph_results directory

$num_args = scalar @ARGV;

if ($num_args > 1 || ($num_args == 1 && $ARGV[0] ne "-ALL")) {
    print "usage: $0 [-ALL]\n";
    print "-ALL will synthesize the entire 8051, not just the rom\n";
    exit;
}

system("rm -rf work");
system("mkdir work");

# synthesizes all2 if ALL is a parameter
if ($num_args == 1) {
    system("dc_shell -f syn_all2.inc > all2.out");
}

system("rm -rf ph_results");
system("mkdir ph_results");

system("cp run_scripts/progrun.scr run.scr");

opendir TESTDIR, "test" or die "Can't open test directory";
@allfiles = readdir TESTDIR;
closedir TESTDIR;

foreach $file (@allfiles) {   
    if ($file =~ /.hex/) {
 	
	# get filename without extension
	@file_name = split /[.]/, $file, 2;
	
#        print "pwrhrchy.pl test/$file ph_results/$file_name[0].xdu\n";
	system("pwrhrchy.pl test/$file ph_results/$file_name[0].xdu");
    }
}

exit;
