#include <iostream.h>
#include <fstream.h>
#include <string>
#include <ctype.h>
#include <strstream.h>
#include <math.h>
#include <stdlib.h>
#include "core_tree.h"

//#define DEBUG

// assumes no line will be bigger than 200 chars
#define MAX_LINE 200
#define MAX_TOKENS 5
const string power_boundary(80, '-');


int main(int argc, char **argv)
{
  core_tree cores;
  char buffer[MAX_LINE];
  string current_line;
  ifstream infile;
  string line[MAX_TOKENS];
  string old_core;

  if (argc != 2)
  {
      cout << "Usage: powerall <input_file>" << endl;
      return -1;
  }

  infile.open(argv[1]);
  
  if (!infile)
  {
      cout << "Error opening " << argv[1] << "." << endl;
      return -1;
  }
  
  int total = 0;
  int count = 0;
  int core = 0;
  int core_count = 0;
  int begin_nets = 0;
  int read_next = 0;
  int line_index = 4;
  string core_name;
  
  while(!infile.eof()) 
  {
      infile.getline(buffer, MAX_LINE, '\n');
      current_line = buffer;

      // waits until all warning have been skipped
	
      if (current_line == power_boundary) 
      {
          // toggle begin_nets to make sure all warnings and useless
          // lines are skipped
	    
          if (begin_nets == 0) {
              begin_nets = 1;	
          }
          else {
              begin_nets = 0;
          }
      }
      else if (begin_nets == 1) {
          
          // send current_line from file to stream and then parse it
          // into MAX_TOKENS - 1

          strstream ist;
          ist << current_line;
          for (int i = 0; i < MAX_TOKENS && ist >> line[i]; i ++);
          
          // reads in power data, read next is used because sometimes
          // the net and the data are on consecutive lines
          
          if (isdigit((line[4].c_str())[0]) || read_next == 1) 
          {    
              if (read_next == 1) {
                  line_index = 3;
              }
              else {
                  core_name = line[0];
                  line_index = 4;
              }
              
              cores.insert(core_name, atof(line[line_index].c_str()));
              
              total ++;
              read_next = 0;
          }
          else {
              // this occurs when the net name and data are on seperate lines.
              
              core_name = line[0];
              read_next = 1;
          }  
          
          for (int j = 0; j < MAX_TOKENS; j++)
            line[j] = "";
      }	 
  } 
  
#ifdef DEBUG
  cout << "Total nets in main  = " << total << endl;
#endif

  cores.print(DU_MODE);
  infile.close();
  
  return 1;
}






