#!/usr/local/bin/perl

# Greg Stitt
# This synthesizes the rom and 8051 if necessary and does power analysis
# on the application specified by hexfile

$num_args = scalar @ARGV;

if ($num_args > 3 || $num_args < 2 || ($num_args == 3 && $ARGV[0] ne "-ALL") 
    || ($ARGV[0] eq "-ALL" && $num_args != 3)) {
    print "usage: $0 [-ALL] hexfile outputfile\n";
    print "-ALL: This will synthesize the entire 8051, not only ROM.\n";
    exit;
}

system("rm -rf work");
system("mkdir work");

if ($num_args == 2) {
    $input = $ARGV[0];
    $output = $ARGV[1];
}
elsif ($num_args == 3) {
    $input = $ARGV[1];
    $output = $ARGV[2];
}

system("g++ -o i8051_mkr i8051_mkr.c");
system("i8051_mkr $input");

if ($ARGV[0] eq "-ALL") {
#    print "-ALL";
    system("synallpow.scr");
}
else {
    system("synrompow.scr");
}

system("make clean -C pwr_hrchy > makeclean.out 2>> makeclean2.out");
system("make -C pwr_hrchy > make.out 2>> make2.out");
system("pwr_hrchy/pwr_hrchy netpower.out > $output"); 








