#!/usr/bin/perl
$number_args = scalar @ARGV;
$MEGA = 1_000_000;
if($number_args == 2) {
    open(PARSEFILE, $ARGV[0]) or die "Can't open $ARGV[0]: $!\n";
    $total = 0;
    $count = 0;
    $core = 0;
    $core_count = 0;
    $begin_nets = 0;
    $read_next = 0;
    $line_index = 4;

    while(<PARSEFILE>) {

	# waits until all warning have been skipped
	
	if (/-{80}/) {
	    # toggle begin_nets to make sure all warnings and useless
	    # lines are skipped
	    
	    if ($begin_nets == 0) {
		$begin_nets = 1;	
	    }
	    else {
		$begin_nets = 0;
	    }
	}
	elsif ($begin_nets == 1) {
	    
	    chomp;
	    s/[\s]+/ /g;
	    @line = split/ /;
	    
	    # reads in power data, read next is used because sometimes
	    # the net and the data are on consecutive lines

	    if ($line[4] =~ /^\d/ || $read_next == 1) {

		if ($read_next == 1) {
		    # updates index and name because net name was on previous
		    # line of file

		    $core_name = $old_core;
		    $line_index = 3;
		}
		else
		{
		    $core_name = $line[0];
		    $line_index = 4;
		}
				  
		$total += $line[$line_index];
		
		if($core_name =~ /^$ARGV[1]/i) {
		    $core += $line[$line_index];
		    $core_count++;
		}
		
#		print "$_\n";
		
		$count++;
		$read_next = 0;
	    }
	    else {
		# this occurs when the net name and data are on seperate
		# lines.
		
#	        print "$_ ";

		$old_core = $line[0];
		$read_next = 1;
	    }
	}	
    }
    
    close(PARSEFILE);
    
    $total = $total * 100 / $MEGA;
    $core = $core * 100 / $MEGA;
    print "total power (mW) = $total\n";
    print "total nets  = $count\n";
    print "core power (mW) = $core\n";
    print "core nets  = $core_count\n";
}
else {
    print "Usage: cpwr <file> <core>\n";
}











